<template>
  <div class="range-with-inputs">

    <div class="range-with-inputs__row">
      <div class="range-with-inputs__inputs">

        <filter-input :placeholder="formatValues(minValue)"
                      :filterType="filterType"
                      :error="fieldErrors[0]"
                      v-model="rangeValues[0]"
                      @input="inputChanged"
        />

        <svg width=".875rem" height=".125rem" viewBox="0 0 14 2"
             class="range-with-inputs__separator">
          <path d="M0 0H14V2H0V0Z" fill="#DCE2EF"/>
        </svg>

        <filter-input :placeholder="formatValues(maxValue)"
                      :filterType="filterType"
                      :error="fieldErrors[1]"
                      v-model="rangeValues[1]"
                      @input="inputChanged"
        />

      </div>

      <span v-if="symbol"
            v-html="symbol"
            class="range-with-inputs__symbol"></span>
    </div>

    <range class="range-with-inputs__range"
           v-model="rangeValues"
           :min="minValue" :max="maxValue"
           :changeFromInput="changeFromInput"
           :filterType="filterType"
           @rangeChanged="rangeChanged"
           ref="range"
    />

    <slot name="checkbox"></slot>

    <button type="button"
            class="button button--green range-with-inputs__btn"
            @click="setGlobalValue">
      Применить
    </button>
  </div>

</template>

<script>
  import FilterInput from '../components/FilterInput';
  import Range from '../components/Range';
  import closeDropdowns from '../assets/js/helpers/close-dropdowns';

  export default {
    name: 'RangeWithInputs',
    props: {
      filterType: {
        type: String,
        default: null
      },

      minValue: {
        type: Number,
        required: true,
      },

      maxValue: {
        type: Number,
        required: true,
      },

      symbol: {
        type: String,
        default: null
      },

      value: {
        type: Array,
        required: true
      },

      timeFlags: {
        type: [Array, String],
        required: true
      },
    },
    components: {
      FilterInput,
      Range
    },
    model: {
      prop: 'value',
      event: 'update'
    },
    data: () => ({
      rangeValues: [],
      changeFromInput: false,
      fieldErrors: [false, false],
    }),
    mounted() {
      if (this.value.length) {
        this.rangeValues = [...this.value];
        this.inputChanged();
      }
    },
    methods: {
      inputChanged() {
        this.changeFromInput = true;
      },

      rangeChanged() {
        this.changeFromInput = false;
      },

      formatValues(value) {
        return this.filterType === 'time'
          ? value < 10
            ? `0${value}:00`
            : `${value}:00`
          : value
      },

      setGlobalValue() {
        if (parseInt(this.rangeValues[0]) > parseInt(this.rangeValues[1]) ) {
          this.fieldErrors = [true, true];

          return;
        }

        if (this.rangeValues[0] || this.rangeValues[1]) {
          this.fieldErrors = [!this.rangeValues[0], !this.rangeValues[1]];

          if (this.fieldErrors.includes(true)) return;
        }

        if (this.rangeValues.length === 2) {
          this.$emit('update', [...this.rangeValues]);
        }

        closeDropdowns();
      },

      reset() {
        this.rangeValues = [];
      }
    },
    watch: {
      timeFlags(val) {

        if (!val.includes('Утро') && !val.includes('Вечер')) {
          this.rangeValues = [];
          this.inputChanged();

          this.$el.querySelectorAll('input').forEach((input) => input.value = '');

          return;
        }


        if ((val.includes('Утро') && val.includes('Вечер'))) {

          this.rangeValues = [this.formatValues(this.minValue), this.formatValues(this.maxValue)];
          this.inputChanged();

        } else if (val.includes('Утро')) {

          this.rangeValues = [this.formatValues(this.minValue), this.formatValues(14)];
          this.inputChanged();

        } else {

          this.rangeValues = [this.formatValues(14), this.formatValues(this.maxValue)];
          this.inputChanged();

        }
      },

      rangeValues: {
        deep: true,

        handler() {
          this.fieldErrors = [false, false];
        },
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .range-with-inputs {
    &__row {
      display: flex;
      align-items: center;
    }

    &__inputs {
      display: flex;
      align-items: center;

      input {
        width: calc(50% - 1rem);
      }
    }

    &__separator {
      margin: 0 rem(10);
    }

    &__symbol {
      @include p1;

      margin-left: rem(14);
      color: rgba($black, .4);
    }

    &__range {
      margin-top: rem(32);
      margin-bottom: rem(42);
    }

    &__btn {
      width: 100%;
    }

  }
</style>
